#ifndef _ROTFL_ROTFL_H
#define _ROTFL_ROTFL_H

void error (const char *errmsg);

typedef unsigned long hashv_t;

hashv_t hash (const char *name);

#include "obj_enum.h"

typedef union object_u *object_t;

enum object_type_e obj_type (object_t obj);

enum pfv_e {
  PF_ID,
  PF_EXIT,
  PF_REF,
  PF_DEREF,
  PF_SET,
  PF_EXCH,
  PF_PRINT,
  PF_WRITE,
  PF_EVAL,
  PF_APPLY,
  PF_CALL_CC,
  PF_QUOTE,
  PF_MAKE_TASK,
  PF_STEP_TASK,
  PF_COUNT
};

#include "o_defs.h"

object_t no_object (void);

#include "new_defs.h"

#include "mod_defs.h"

void invoke (void);

extern object_t mainprog;

void make_globenv (void);

extern object_t globenv;

#endif /* not defined _ROTFL_ROTFL_H */
